﻿using System.Collections.Generic;
using System.Web.Mvc;
using Kreta.BusinessLogic.Classes;
using Kreta.Enums.ManualEnums.ImportExport;
using Kreta.Resources;
using Kreta.Web.Helpers;
using Kreta.Web.Models;
using Kreta.Web.Security;

namespace Kreta.Web.Areas.ImportExport.Models.CommonModels
{
    public class BaseImportExportModel : UploadFileModel
    {
        public int ImportMuvelet { get; set; }

        public List<SelectListItem> ImportMuveletSelectList => EnumExtensions.EnumToDictionary<ImportMuveletEnum>(ClaimData.SelectedTanevID.Value).ToSelectListItemList(selectedValue: (int)ImportMuveletEnum.Insert);

        public List<SelectListItem> ImportMuveletSelectListWithoutDelete => EnumExtensions.EnumToDictionary<ImportMuveletEnum>(ClaimData.SelectedTanevID.Value).ToSelectListItemList(new List<string> { ((int)ImportMuveletEnum.DeleteAndInsert).ToString() }, (int)ImportMuveletEnum.Insert);

        public List<SelectListItem> ImportMuveletSelectListOnlyInsertAndUpdate => EnumExtensions.EnumToDictionary<ImportMuveletEnum>(ClaimData.SelectedTanevID.Value).ToSelectListItemList(new List<string> { ((int)ImportMuveletEnum.DeleteAndInsert).ToString(), ((int)ImportMuveletEnum.Insert).ToString() }, (int)ImportMuveletEnum.InsertAndUpdate);

        public List<SelectListItem> ImportMuveletSelectListOnlyInsert => EnumExtensions.EnumToDictionary<ImportMuveletEnum>(ClaimData.SelectedTanevID.Value).ToSelectListItemList(new List<string> { ((int)ImportMuveletEnum.DeleteAndInsert).ToString(), ((int)ImportMuveletEnum.InsertAndUpdate).ToString() }, (int)ImportMuveletEnum.Insert);

        public List<SelectListItem> ImportMuveletSelectListOnlyInsertAndDelete => GetDeleteAndInsertWithNonImported(EnumExtensions.EnumToDictionary<ImportMuveletEnum>(ClaimData.SelectedTanevID.Value)).ToSelectListItemList(new List<string> { ((int)ImportMuveletEnum.InsertAndUpdate).ToString() }, (int)ImportMuveletEnum.Insert);

        public List<SelectListItem> ImportMuveletSelectListWithDeleteNonImported => GetDeleteAndInsertWithNonImported(EnumExtensions.EnumToDictionary<ImportMuveletEnum>(ClaimData.SelectedTanevID.Value)).ToSelectListItemList(selectedValue: (int)ImportMuveletEnum.Insert);

        private Dictionary<string, string> GetDeleteAndInsertWithNonImported(Dictionary<string, string> dict)
        {
            var ret = new Dictionary<string, string>(dict)
            {
                [ImportMuveletEnum.DeleteAndInsert.AsInt().ToString()] = ImportExportCommonResource.ImportTipusEnumDeleteAndInsertImported
            };
            return ret;
        }
    }
}
